checkRequire("Lua_SkillTipsWindow")
Lua_ArtifactSkillTipsWindow = class("Lua_ArtifactSkillTipsWindow", Lua_SkillTipsWindow)
function Lua_ArtifactSkillTipsWindow:ctor()
	self:superCall("ctor")
	self.windowName = "Lua_ArtifactSkillTipsWindow"
end

function Lua_ArtifactSkillTipsWindow:dispose()
	if self.skillArr then
		self.skillArr:clear()
		self.skillArr = nil
	end
	if self.skillItemArr then
		self.skillItemArr:dispose()
		self.skillItemArr:clear()
		self.skillItemArr = nil
	end
	self:superCall("dispose")
end

function Lua_ArtifactSkillTipsWindow:showSkillInfo()
	self:superCall("showSkillInfo")
	self.skill_round:setEnable(false)
end

function Lua_ArtifactSkillTipsWindow:showSkillDesList()
	local space = 15
	self.show_h = self.show_h - space
	self.fengxian2:setEnable(true)
	self.fengxian2:setLocation(0, self.show_h, 0)
	self.show_h = self.show_h - space

	if self.skillArr == nil then
		self.skillArr = Array()
		if self.skillVo.level > 1 then
			self.skillArr:add(self.skillVo)
		end

		local data = self.skillVo
		while true do
			if data.prevId > 0 then
				data = Lua_SkillConfigData.getConfigData(data.prevId)
				if data.level > 1 then
					self.skillArr:add(data)
				end
			else
				break
			end
		end

		data = self.skillVo
		while true do
			if data.nextId > 0 then
				data = Lua_SkillConfigData.getConfigData(data.nextId)
				if data.level > 1 then
					self.skillArr:add(data)
				end
			else
				break
			end
		end

		quickSort(self.skillArr, "level", true)

		self.skillItemArr = Array()
	end

	space = 10
	local len = self.skillArr:getSize()
	local item
	local height
	for i = 1, len do
		item = self.skillItemArr[i]
		if item == nil then
			item = Lua_ArtifactSkillDesItem.new(self.showObj)
			self.skillItemArr:add(item)
		end
		height = item:setData(self.skillArr[i].level <= self.skillVo.level, self.skillArr[i])
		item:setLocation(0, self.show_h, 0)
		self.show_h = self.show_h - height - space
	end
end





















Lua_ArtifactSkillDesItem = class("Lua_ArtifactSkillDesItem", Lua_DisplayObject)
function Lua_ArtifactSkillDesItem:ctor(p)
	self:superCall("ctor", p)
end

function Lua_ArtifactSkillDesItem:buildShowItem()
	self:superCall("buildShowItem")
	self.starArr = Array()

	self.desText = UICreate.createLabel(self.content, nil, -89, 0, 285, 31, 22)
	self.desText.alignmentValue = 0
	self.desText.pivotValue = 0
	self.desText.horizontalOverflowValue = 0
	self.desText.verticalOverflowValue = 1
end

function Lua_ArtifactSkillDesItem:dispose()
	if self.starArr then
		self.starArr:dispose()
		self.starArr:clear()
		self.starArr = nil
	end
	self.desText = nil
	self:superCall("dispose")
end

function Lua_ArtifactSkillDesItem:setData(bUnlock, data)
	self:showStar(data.level)
	if bUnlock then
		self.desText.colorStr = Lua_ColorDefine.transColor("FFE070")
	else
		self.desText.colorStr = Lua_ColorDefine.transColor("898B8A")
	end
	self.desText.text = data["des"..data.level]
	self.desText:resetSize()
	return self.desText.height
end

function Lua_ArtifactSkillDesItem:showStar(value)
	local len = self.starArr:getSize()
	value = value or 0
	len = value - len
	
	local star
	while (len > 0) do
		star = UICreate.createUIAtlasImage(self.content, "common_altas_1", "xui_common_label_05", 0, 0, 0, 0)
		self.starArr:add(star)
		len = len - 1
	end

	while (len < 0) do
		star = self.starArr:remove()
		star:dispose()
		len = len + 1
	end

	len = self.starArr:getSize()
	local space = 20
	local w = -(space * len) / 2 + space / 2
	for i = 1, len do
		star = self.starArr[i]
		star:setLocation(-147 + ((i - 1) % len) * space + w, -15, 0)
	end
end