Lua_InstructionTipsWindow = class("Lua_InstructionTipsWindow", Lua_Window);
function Lua_InstructionTipsWindow:ctor()
    self:superCall("ctor");

    self.layer = MainWinDefine.TIPS_WINDOW_LAYER;
    self.windowName = "Lua_InstructionTipsWindow";
    self.isFullSizeWin = true;
    self.showBlackMask = true;
    self.blackAlpha = 0.01;
    self.isClickClose = true;
end

function Lua_InstructionTipsWindow:buildShowItem()
    self:superCall("buildShowItem");
    self.showContainer = Lua_WindowUtil.createContainer(self.content)
end

function Lua_InstructionTipsWindow:dispose()
    self.tipsImg = nil;
    if self.tipsContainer ~= nil then
        self.tipsContainer:dispose();
        self.tipsContainer = nil;
    end
    if self.showContainer ~= nil and IsNil(self.showContainer) == false then
        UnityEngine.GameObject.Destroy(self.showContainer);
        self.showContainer = nil;
    end
    self:superCall("dispose");
end

function Lua_InstructionTipsWindow:showWin(param)
    self:superCall("showWin", param)

    if param.maxWidth == nil then
        self.maxWidth = 253
    else
        self.maxWidth = param.maxWidth
    end
    if param.maxHeight == nil then
        self.maxHeight = 295
    else
        self.maxHeight = param.maxHeight
    end
    if param.posX == nil then
        self.posX = 0
    else
        self.posX = param.posX
    end
    if param.posY == nil then
        self.posY = 0
    else
        self.posY = param.posY
    end
    if param.needAdapt == nil then
        self.needAdapt = true
    else
        self.needAdapt = param.needAdapt
    end
    if param.isBottomShow == nil then
        self.isBottomShow = false
    else
        self.isBottomShow = param.isBottomShow
    end

    if self.needAdapt then
        if self.isBottomShow == false then
            LuaUtil.setObjAnchor(self.showContainer, UIUtils.Anchor.Top)
        else
            LuaUtil.setObjAnchor(self.showContainer, UIUtils.Anchor.Bottom)
        end
    else
        LuaUtil.setObjAnchor(self.showContainer, UIUtils.Anchor.Center)
    end
    LuaUtil.setObjPos(self.showContainer, self.posX, self.posY, 0)

    if self.tipsImg == nil then
        self.tipsImg = UICreate.createUIAtlasImage(self.showContainer, "common_altas_1", "xui_common_tips_001", 0, 0, self.maxWidth, self.maxHeight)
        self.tipsImg.typeValue = 1
    end

    if self.tipsContainer == nil then
        self.tipsContainer = Lua_DragContainer.new(self.showContainer, self.maxWidth - 33, self.maxHeight - 40, Lua_AxisDefine.Vertical)
        self.tipsContainer:setLocation(0, 4, 0)
        self.tipsContainer:addSubContainer(Lua_InstructionTipsItem, param, true)
        self.tipsContainer.canDrag = not self.tipsContainer.isTheEnd
    end

    LuaUtil.setObjScale(self.showContainer, 0, 0, 0)
    TweenUtil.getInstance():stop(self.showContainer)
    TweenUtil.getInstance():addTweenTargetScale(self.showContainer, 0.2, 0, 1, 1, 1, 1.1, false)
end





















Lua_InstructionTipsItem = class("Lua_InstructionTipsItem", Lua_DragContainerItem);
function Lua_InstructionTipsItem:ctor(p)
    self:superCall("ctor", p);
end

function Lua_InstructionTipsItem:buildShowItem()
    self:superCall("buildShowItem");

    self.tipsText = UICreate.createLabel(self.content, nil, 0, 0, 100, 0, 20);
    self.tipsText.verticalOverflowValue = 1;
end

function Lua_InstructionTipsItem:dispose()
    self:superCall("dispose");
end

function Lua_InstructionTipsItem:getWidth()
    return self.tipsText.width;
end

function Lua_InstructionTipsItem:getHeight()
    return self.tipsText.height;
end

function Lua_InstructionTipsItem:setData(data)
    local maxWidth = data.maxWidth == nil and 253 or data.maxWidth
    self.tipsText:SetDimensions(maxWidth - 33, 0)
    if type(data.des) == type_str_number then
        self.tipsText:setLangValue(data.des)
    else
        self.tipsText.text = data.des
    end
    self.tipsText:resetSize()
end