-- 奖励预览
Lua_RewardPreviewWindow = class("Lua_RewardPreviewWindow", Lua_Window);
function Lua_RewardPreviewWindow:ctor()
	self:superCall("ctor");

	self.w = 0;
	self.h = 0;
	self.windowName = "Lua_RewardPreviewWindow";
	self.isFullSizeWin = true;
	self.showBlackMask = true;
	self.blackAlpha = 0.1;
	self.showWinBg = true;
	self.winBgAtlas = "common_altas_1";
	self.winBgSprite = "ui_common_window_009";
	self.isClickClose = true;
	
end

function Lua_RewardPreviewWindow:buildShowItem()
	self:superCall("buildShowItem");
	self.winBg.pivotValue = 4;
end

function Lua_RewardPreviewWindow:dispose()
	if self.itemList ~= nil then
		self.itemList:dispose();
		self.itemList = nil;
	end
	self:superCall("dispose");
end

function Lua_RewardPreviewWindow:showWin(param)
	self:superCall("showWin", param);
	if self.showTime ~= nil and getTime() - self.showTime < 0.3 then
		return;
	end
	self.showTime = getTime();

	local itemW = param.itemW == nil and 68 or param.itemW;
	local itemNum = param.itemNum == nil and 1 or param.itemNum;
	local spacingX = param.spacingX == nil and 0 or param.spacingX;
	local spacingY = param.spacingY == nil and 0 or param.spacingY;
	local itemList = param.itemList;
	local width;
	if itemList.typeof ~= nil and itemList:typeof() == "Array" then
		width = itemW * itemList:getSize();
	else
		width = itemW * #itemList;
	end
	self.winBg:SetDimensions(width + 30, itemW + 30);
	if self.itemList == nil then
		self.itemList = Lua_DragList.new(self.content, width, itemW, Lua_AxisDefine.Horizontal);
		self.itemList:setListCell(Lua_RewardPreviewItem, itemW, itemW, itemNum);
		self.itemList:setCellSpacing(spacingX, spacingY);
	end
	self.itemList:setArrayData(itemList);
	self.itemList.canDrag = not self.itemList.isTheEnd;

	if param.needAdapt ~= false then
		if param.isBottomShow == true then
			self.winBg.anchorValue = 7;
			self.itemList:setRectAnchor(7);
		else
			self.winBg.anchorValue = 1;
			self.itemList:setRectAnchor(1);
		end
	else
		self.winBg.anchorValue = 4;
		self.itemList:setRectAnchor(4);
	end

	local half_w = 30 + width / 2;
	local posX = param.posX;
	if posX > 0 then
		if posX + half_w > self.width / 2 then
			posX = posX - (posX + half_w - self.width / 2) / 2;
		end
	elseif posX < 0 then
		if posX - half_w < -self.width / 2 then
			posX = posX + (Mathf.Abs(posX - half_w) - self.width / 2) / 2;
		end		
	end

	posY = param.posY + 85;
	self.winBg:setLocation(posX, posY, 0);
	self.itemList:setLocation(posX, posY, 0);
end




















Lua_RewardPreviewItem = class("Lua_RewardPreviewItem", Lua_ItemIconCell);
function Lua_RewardPreviewItem:buildShowItem()
    self:superCall("buildShowItem");
    self.itemIcon:setScale(0.6, 0.6);
end