-- 技能Tips
checkRequire("Lua_HeroConnectIconItem")
Lua_SkillTipsWindow = class("Lua_SkillTipsWindow", Lua_Window);
function Lua_SkillTipsWindow:ctor()
	self:superCall("ctor");

	self.layer = Lua_MainWinDefine.TIPS_WINDOW_LAYER;
	self.showBlackMask = true;
	self.isClickClose = true;
	self.windowName = "Lua_SkillTipsWindow";
	self.skinName = "SkillTipsWindow_skin";
end

function Lua_SkillTipsWindow:buildShowItem()
	self:superCall("buildShowItem");
end

function Lua_SkillTipsWindow:showWin(param)
	self:superCall("showWin", param);

	if type(param) == "table" then
		-- skiil_vo  	技能vo
		-- skill_level  技能等级 （不显示等级的技能不赋值）
		-- unlock_type	解锁类型 1:需要解锁条件，展示所有等级技能描述，2:需要解锁条件，展示满足解锁等级的技能描述 nil:无需条件，展示配置所有等级技能描述
		-- unlock_level 解锁等级 (现在神器使用)
		-- extra_des    额外描述效果展示
		-- bActConnect  是否激活连携
		-- connectVo    连携vo
		if param.skillVo == nil then
			self.skillVo = param;
		else
			self.skillVo = param.skillVo;
			self.skill_level = param.skill_level;
			self.unlock_type = param.unlock_type;
			self.unlock_level = param.unlock_level;
			self.show_extra = param.extra_des;
			self.bActConnect = param.bActConnect;
			self.connectVo = param.connectVo;
		end
	elseif type(param) == "number" then
		self.skillVo = Lua_SkillConfigData.getConfigData(param);
	end
	self.skillEffectVo = Lua_SkillEffectConfigData.getConfigData(self.skillVo.skillEffID);
	self:showSkillInfo();
	self:updataAdaptive(); -- 更新适配
end

--技能基础信息
function Lua_SkillTipsWindow:showSkillInfo()
	self.skill_name.text = self.skillVo.name;
	self.skill_type.text = self.skillVo.skillTypeName;
	if self.skillVo.skillType == 2 then
		if self.skillVo.show_cool_round > 0 then
			self.skill_cool.text = LanUtil.formateStr(126105, tostring(self.skillVo.cool_round));
		else
			self.skill_cool:setLangValue(126120);
		end
	else
		self.skill_cool.text = LanUtil.formateStr(126105, tostring(self.skillVo.cool_round));
	end
	self.skill_icon:setAltas(self.skillVo.atlas, self.skillVo.sprite);

	--技能等级
	if self.skill_level ~= nil then
		local lvl = self.skill_level == 0 and 1 or self.skill_level;
		self.skill_lvl.text = "Lv."..lvl;
		self.skill_lvl:setEnable(true);
	else
		self.skill_lvl:setEnable(false);
	end

	if self.skillVo.skillType == 2 then
		self.skill_round:setEnable(false);
	else
		self.skill_round.text = LanUtil.formateStr(126104, tostring(self.skillVo.start_round));
	end
end

function Lua_SkillTipsWindow:updataAdaptive() -- 更新适配
	self.show_h = -128;--基础信息固定高度
	self:showConnect();
	self:showSkillTag();
	self:showSkillDes();
	self:showSkillDesList();
	self:showSkillExtraDes();
	self:showSkillBuff();
	local space = 6;--底部间距
	self.show_h = self.show_h -space;

	LuaUtil.setObjPos(self.showObj, 0, Mathf.Abs(self.show_h/2), 0);
	self.winBg:SetDimensions(435, Mathf.Abs(self.show_h)+ 40);
end

--连携条件展示
function Lua_SkillTipsWindow:showConnect()
	if self.skillVo.connect_id == 0 then
		return
	end

	if self.connectVo == nil then
		return
	end
	self.skill_icon_bj:setAltas("hero_altas","xui_hb_widget_16");
	self.skill_icon_bj:resetSize();
	local space = 13;
	self.show_h = self.show_h - space;

	self.connectArr = Array();
	local arr = self.connectVo.condInfo;
	local item
	for i = 1, arr:getSize() do
		item = self.connectArr[i]
		if item == nil then
			item = Lua_HeroConnectIconItem.new(self.showObj);
			item:setScale(0.7,0.7);
			self.connectArr:add(item);
		end
		item:setData(self.connectVo, arr[i]);
		item:setLocation(-151+(i - 1)*101, -191, 0)
	end

	self.show_h = self.show_h-99-13;

	self.fengxian2:setEnable(true);
	self.fengxian2:setLocation(0, self.show_h, 0);
	self.show_h = self.show_h-3;
end

--技能标签
function Lua_SkillTipsWindow:showSkillTag()
	self.tagInfo = Array();
	local item;
	local item_w = 0;
	local list = self.skillEffectVo.skill_tag;
	if list ~= nil and #list > 0 then
		local tag_w = 33;
		local space = 12;
		self.show_h = self.show_h - tag_w/2 - space;
		for i=1,#list do
			item = Lua_SkillTagItem.new(self.showObj);
			item:setData(list[i]);
			if i > 1 then
				item_w = self.tagInfo[i-1].bg_w + item_w + 11;--  + 11 间距
			end
			item:setLocation(-197 + item_w, self.show_h, 0);
			self.tagInfo:add(item);
		end
		self.show_h = self.show_h - tag_w/2;
	end
end

--技能描述
function Lua_SkillTipsWindow:showSkillDes()
	if self.unlock_type == 1 then--展示解锁条件 
		if self.skill_level ~= nil and self.skill_level == 0 then --1技能未激活
			local unlock_des = LanUtil.formateStr(126106, tostring(self.unlockLevel));
			self.skill_des.text = "<color=#b9b9b9>"..self.skillEffectVo.des.."</color>"..unlock_des;
		else
			self.skill_des.text = self.skillEffectVo.des;
		end
	elseif self.unlock_type == 3 then--展示连携激活条件
		local str = "";
		if self.bActConnect == false then--连携未激活
			str = LanUtil.getValue(126064);
		end
		self.skill_des.text = self.skillEffectVo.des..str;
	else
		self.skill_des.text = self.skillEffectVo.des
	end
	self.skill_des:resetSize();

	local space = 7;
	self.show_h = self.show_h - space;
	self.skill_des:setLocation(-191, self.show_h, 0);

	self.show_h = self.show_h - self.skill_des.height;
end

--技能解锁等级描述
function Lua_SkillTipsWindow:showSkillDesList()
	self.desInfo = Array();
	local show_index = 0;--展示技能索引(默认展示所有技能描述)
	if self.unlock_type == 2 then
		show_index = self.unlock_index;
	end
	if show_index == nil or show_index == 1 then
		return;
	end
	local list = self.skillEffectVo.unlock_level_list;
	if list ~= nil and #list > 1 then
		local space = 15;
		self.show_h = self.show_h - space;
		self.fengxian2:setEnable(true);
		self.fengxian2:setLocation(0, self.show_h, 0);
		self.show_h = self.show_h - space;

		local item;
		local len = #list;
		for i = 1, len do
			if show_index == 0 or show_index >= i then
				if not strIsNullOrEmpty(self.skillEffectVo["des"..i]) then
					item = Lua_SkillDesItem.new(self.showObj);
					
					if self.unlock_type == 1 and list[i] ~= 999 then--暂时英雄技能展示需要展示解锁条件
						local isUnlock = self.unlockLevel >= list[i];--是否解锁
						local show_tips = (self.unlock_index+1) == i and self.skill_level > 0;--是否展示解锁Tips
						item:isShowUnlock(isUnlock, show_tips);
					end

					item:setIndex(i);--展示技能索引
					item:setData(self.skillEffectVo);
					item:setLocation(-191, self.show_h, 0);
					local space1;
					if show_index == 0 then
						space1 = len == i and 0 or 10;
					else
						space1 = show_index == i and 0 or 10;
					end
					self.show_h = self.show_h - item.des_h - space1;
					self.desInfo:add(item);
				end
			end
		end
	end
end

--展示额外效果描述
function Lua_SkillTipsWindow:showSkillExtraDes()
	if self.show_extra ~= nil then
		self.fengxian4:setEnable(true);
		local space = 15;
		self.show_h = self.show_h - space;
		self.fengxian4:setLocation(0, self.show_h, 0);
		self.show_h = self.show_h - space;

		self.extra_des.text = self.show_extra;
		self.extra_des:resetSize();
		self.extra_des:setLocation(-191, self.show_h, 0);
		self.show_h = self.show_h - self.extra_des.height;

		self.fengxian4:setEnable(true);
		self.extra_des:setEnable(true);
	else
		self.extra_des:setEnable(false);
	end
end

--技能buff
function Lua_SkillTipsWindow:showSkillBuff()
	local list = self.skillEffectVo.buff_list;
	if list ~= nil and #list > 0 then
		local space = 15;
		self.show_h = self.show_h - space;
		self.fengxian3:setEnable(true);
		self.fengxian3:setLocation(0, self.show_h, 0);
		self.show_h = self.show_h - space;

		local showList = {};
		if self.unlock_type == 2 and self.unlock_index ~= nil then
			local tag_index = 0;
			for i=1,#list do
				if i <= self.unlock_index and list[i][1] ~= nil then--已解锁的索引Buff
					for j=1,#list[i] do
						tag_index = tag_index +1;
						showList[tag_index] = list[i][j];
					end
				end
			end
		else
			showList = list;
		end

		local item;
		self.buffInfo = Array();
		local len = #showList;
		for i=1, len do
			item = Lua_SkillBuffItem.new(self.showObj);
			item:setData(showList[i]);
			item:setLocation(-201, self.show_h, 0)

			local space1 = len == i and 0 or 10;
			self.show_h = self.show_h - item.des_h - space1;
			self.buffInfo:add(item);
		end
	end
end

--获取解锁索引
function Lua_SkillTipsWindow.Get:unlock_index()
	if self._unlockIndex == nil then
		local unlock_level_list = self.skillEffectVo.unlock_level_list;
		if unlock_level_list ~= nil then
			for i=1,#unlock_level_list do
				if unlock_level_list[i] <= self.unlockLevel then
					self._unlockIndex = i;
				else
					break;
				end
			end
		end
	end
	return self._unlockIndex;
end

--获取解锁等级
function Lua_SkillTipsWindow.Get:unlockLevel()
	--skill_level 作为 unlock_level_list[解锁等级,解锁等级,解锁等级,...]字段的索引
	if self.skill_level ~= nil then
		local index = self.skill_level == 0 and 1 or self.skill_level;
		local list = self.skillEffectVo.unlock_level_list;
		if list[index] ~= nil then
			return list[index];
		end
	end
	if self.unlock_level ~= nil then
		return self.unlock_level;
	end

	return 9999;
end

function Lua_SkillTipsWindow:dispose()
	if self.desInfo ~= nil then
		self.desInfo:dispose();
		self.desInfo:clear();
		self.desInfo = nil;
	end

	if self.tagInfo ~= nil then
		self.tagInfo:dispose();
		self.tagInfo:clear();
		self.tagInfo = nil;
	end

	if self.buffInfo ~= nil then
		self.buffInfo:dispose();
		self.buffInfo:clear();
		self.buffInfo = nil;
	end

	if self.connectArr then
		self.connectArr:dispose()
		self.connectArr:clear()
		self.connectArr = nil
	end
	self.connectVo = nil;
	self.skillVo = nil;
	self.skillEffectVo = nil;
	self:superCall("dispose");
end















-- 技能解锁等级描述
Lua_SkillDesItem = class("Lua_SkillDesItem", Lua_DisplayObject);
function Lua_SkillDesItem:ctor(p)
	self:superCall("ctor", p, "SkillDesItem_skin");
end

function Lua_SkillDesItem:buildShowItem()
	self:superCall("buildShowItem");
end

--技能索引
function Lua_SkillDesItem:setIndex(index)
	self.index = index;
end

--技能是否解锁/是否展示tips
function Lua_SkillDesItem:isShowUnlock(bool, showTips)
	self.isUnlock = bool;
	self.showTips = showTips;
end

function Lua_SkillDesItem:setData(skillEffVo)
	local show_des
	local list = skillEffVo.unlock_level_list;
	if list[self.index] == 999 then
		show_des = LanUtil.getValue(126112);--技能无法升级
	else
		local skill_des = skillEffVo["des"..self.index]
		if not strIsNullOrEmpty(skill_des) then
			if self.isUnlock ~= nil then--展示解锁条件
				local str = "";
				local color = "FFFFFF";
				if self.isUnlock == false then --未解锁
					color = "b9b9b9";
					if self.showTips then
						str = LanUtil.formateStr(126106, tostring(list[self.index]));
					end
				end
				show_des = "<color=#"..color..">"..skill_des.."</color>"..str;
			else
				show_des = skill_des;
			end
		end
	end

	self.skill_des.text = show_des;
	self.skill_des:resetSize();
end

function Lua_SkillDesItem.Get:des_h()
	return self.skill_des.height;
end

function Lua_SkillDesItem:dispose()
    self:superCall("dispose");
end
















-- 技能标签
Lua_SkillTagItem = class("Lua_SkillTagItem", Lua_DisplayObject);
function Lua_SkillTagItem:ctor(p)
	self:superCall("ctor", p, "SkillTagItem_skin");
end

function Lua_SkillTagItem:buildShowItem()
	self:superCall("buildShowItem");
end

function Lua_SkillTagItem:setData(data)
	self.tag_name.text = data;
	self.tag_name:resetSize();
    self.tag_bg:SetDimensions(self.tag_name.width + 24, 33);
end

function Lua_SkillTagItem.Get:bg_w()
	return self.tag_bg.width;
end

function Lua_SkillTagItem:dispose()
    self:superCall("dispose");
end
















-- 技能buff
Lua_SkillBuffItem = class("Lua_SkillBuffItem", Lua_DisplayObject);
function Lua_SkillBuffItem:ctor(p)
	self:superCall("ctor", p, "SkillBuffItem_skin");
end

function Lua_SkillBuffItem:buildShowItem()
	self:superCall("buildShowItem");
end

function Lua_SkillBuffItem:setData(buff_id)
	local buffData = Lua_BuffConfigData.getConfigData(buff_id);
	if buffData ~= nil then
		self.skill_show.text = "【"..buffData.name.."】";
		self.skill_show:resetSize();
		self.skill_effect.text = buffData.effect_des;
		self.skill_effect:resetSize();
	end
end

function Lua_SkillBuffItem.Get:des_h()
	return self.skill_effect.height + self.skill_show.height;
end

function Lua_SkillBuffItem:dispose()
    self:superCall("dispose");
end