--[[
if DataCenter.neverTipData:getNeverValue(Lua_NeverTipDefine.NONE) then
	self:onSureCallback();
else
	local param = {
		h = 473, --界面高度
		titleAtlas = "common_altas_3",
		titleSprite = "ui_hy_title_02",
		pivot = Lua_WindowUtil.getPivot(4),
		alignmentValue = 4,
		font_size = 24,
		des = LanUtil.getValue(1),
		posX = 0,
		posY = 0,

		secDes = "<color=#4A6793>[201000001]是否消耗[201000002]<color=#FFFFFF>100</color></color>",
		secDesPosX = 0,
		secDesPosY = 0,

		neverTip = Lua_NeverTipDefine.NONE,
		btnType = 1,
		time = 0,
		owner = self,
		cancelFun = self.onCancelFun,
		sureFun = self.onSureFun
	};
	Lua_WindowUtil.openWin("Lua_TipsWindow", Lua_WinParam.ACTION_OPEN, param);
end
]]

Lua_TipsWindow = class("Lua_TipsWindow", Lua_TipsBaseWindow);
function Lua_TipsWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_TipsWindow";
	self.showWinBg = true;
	self.showTitle = true;
	self.showClose = true;
end

function Lua_TipsWindow:buildShowItem()
	self:superCall("buildShowItem");
end

function Lua_TipsWindow:dispose()
	Lua_CommonUtil.removeTimer(self, self.updatabtnSureTime);
	self.des = nil;
	self.secDes = nil;
	self.cbSelect = nil;
	self:cleanShowData();
	if self.showParams ~= nil then
		self.showParams:clear();
		self.showParams = nil;
	end
	self:superCall("dispose");
end

function Lua_TipsWindow:showWin(param)
	if self.showTime ~= nil and getTime() - self.showTime < 0.3 then
		return;
	end
	self.showTime = getTime();

	if self.showParams == nil then
		self.showParams = Array();
	end
	self.showParams:add(param);
	self:showNext();
end

function Lua_TipsWindow:showNext()
	if self.showParams == nil or self.showParams:getSize() <= 0 then
		self:hide();
		return;
	end

	self.showData = self.showParams[1];
	if self.showData == nil then
		self:hide();
		return;
	end

	self:updateShowInfo();
end

function Lua_TipsWindow:updateShowInfo()
	self.h = self.showData.h == nil and 473 or self.showData.h;

	if self.showData.titleText then
		self.titleName.text = self.showData.titleText
	else
		self.titleName:setLangValue(100000)
	end
	self.titleName:resetSize()
	self:createTitleDeco()

	local font_size = self.showData.font_size == nil and 27 or self.showData.font_size;
	local pivot = self.showData.pivot == nil and Lua_WindowUtil.getPivot(4) or self.showData.pivot;
	local alignmentValue = self.showData.alignmentValue == nil and 4 or self.showData.alignmentValue;
	local width;
	local height;
	local posX;
	local posY;
	if self.showData.des == nil then
		if self.des ~= nil then
			self.des:setEnable(false);
		end
	else
		if self.des == nil then
			self.des = UICreate.createLabel(self.content, nil, 0, 0, 100, 40, font_size);
			self.des.colorStr = Lua_ColorDefine.transColorStr("726763");
		end
		self.des:setEnable(true);
		self.des:SetDimensions(100, 40);
		self.des.pivot = pivot;
		self.des.alignmentValue = alignmentValue;
		self.des.horizontalOverflowValue = 1;
		self.des.verticalOverflowValue = 1;
		if type(self.showData.des) == type_str_number then
			self.des:setLangValue(self.showData.des);
		else
			self.des.text = self.showData.des;
		end
		self.des:resetSize();

		width = self.showData.width == nil and self.w - 104 or self.showData.width;
		height = self.showData.height == nil and 40 or self.showData.height;
		if self.des.width >= width then
			self.des.alignmentValue = 3;
			self.des.horizontalOverflowValue = 0;
			self.des:SetDimensions(width, height);
		end

		posX = self.showData.posX == nil and 0 or self.showData.posX;
		posY = self.showData.posY == nil and 8.5 or self.showData.posY;
		self.des:setLocation(posX, posY, 0);
	end

	if self.showData.secDes == nil then
		if self.secDes ~= nil then
			self.secDes:setEnable(false);
		end
	else
		if self.secDes == nil then
			self.secDes = UICreate.createLabel(self.content, nil, 0, 0, 100, 40, font_size);
			self.secDes.colorStr = Lua_ColorDefine.transColorStr("726763");
		end
		self.secDes:setEnable(true);
		self.secDes:SetDimensions(100, 40);
		self.secDes.pivot = pivot;
		self.secDes.alignmentValue = alignmentValue;
		self.secDes.horizontalOverflowValue = 1;
		self.secDes.verticalOverflowValue = 1;
		self.secDes.text = self.showData.secDes;
		self.secDes:resetSize();

		width = self.showData.secDesW == nil and self.w - 103 or self.showData.secDesW;
		height = self.showData.secDesH == nil and 40 or self.showData.secDesH;
		if self.secDes.width >= width then
			self.secDes.alignmentValue = 3;
			self.secDes.horizontalOverflowValue = 0;
			self.secDes:SetDimensions(width, height);
		end

		posX = self.showData.secDesPosX == nil and 0 or self.showData.secDesPosX;
		posY = self.showData.secDesPosY == nil and 8.5 or self.showData.secDesPosY;
		self.secDes:setLocation(posX, posY, 0);
	end

	posY = -(self.h / 2 - 61)
	if self.showData.btnType == 1 then
		self.btnCancel:setEnable(true);
		self.btnSure:setEnable(true);
		self.btnClose:setEnable(true);
		self.isClickClose = true;
	elseif self.showData.btnType == 2 then
		self.btnCancel:setEnable(false);
		self.btnSure:setEnable(true);
		self.btnSure:setLocation(0, posY, 0);
		self.btnClose:setEnable(true);
		self.isClickClose = true;
	elseif self.showData.btnType == 3 then
		self.btnCancel:setEnable(false);
		self.btnSure:setEnable(false);
		self.btnClose:setEnable(false);
		self.isClickClose = false;
	elseif self.showData.btnType == 4 then
		self.btnCancel:setEnable(false);
		self.btnSure:setEnable(true);
		self.btnSure:setLocation(0, posY, 0);
		self.btnClose:setEnable(false);
		self.isClickClose = false;
	else
		self.btnCancel:setEnable(false);
		self.btnSure:setEnable(false);
		self.btnClose:setEnable(true);
		self.isClickClose = true;
	end

	local value = self.showData.cancelLabel
	if value == nil then
		self.btnCancel:setLangValue(100001)
	elseif type(value) == type_str_number then
		self.btnCancel:setLangValue(value)
	else
		self.btnCancel.label = value
	end
	value = self.showData.sureLabel
	if value == nil then
		self.btnSure:setLangValue(100002)
	elseif type(value) == type_str_number then
		self.btnSure:setLangValue(value)
	else
		self.btnSure.label = value
	end

	if self.btnSure ~= nil then
		if self.showData.sureFontSize ~= nil then
			self.btnSure.txt.fontSize = self.showData.sureFontSize;
		end

		if self.showData.time ~= nil and self.showData.time > 0 then
			self.btnSure:setMouseEnable(false);
			self.btnSure:setStyle(7);
			self.btnSure.label = LanUtil.formateStr(107499, tostring(self.showData.time));

			self.sureCountDown = self.showData.time;
			Lua_CommonUtil.addTimer("Lua_TipsWindow", 1, self, self.updatabtnSureTime);
		end
	end

	if self.showData.neverTip ~= nil then
		if self.cbSelect == nil then
			self.cbSelect = UICreate.createCheckBox(self.content, nil, 0, 0, 100, 33);
			self.cbSelect:setStyle(2);
			self.cbSelect:addBoxChange(self, self.onCheckBoxChange);
		end
		self.cbSelect:setEnable(true);

		posX = self.showData.cbPosX == nil and -115 or self.showData.cbPosX;
		posY = self.showData.cbPosY == nil and -50 or self.showData.cbPosY;
		self.cbSelect:setLocation(posX, posY, 0);

		if self.showData.cbDes == nil then
			self.cbSelect:setLangValue(10030);
		else
			self.cbSelect.label = self.showData.cbDes;
		end
		self.cbSelect.selected = false;
	else
		if self.cbSelect ~= nil then
			self.cbSelect:setEnable(false);
		end
	end

	if self.showData.layer ~= nil and self.layer ~= self.showData.layer then
		self.layer = self.showData.layer;
		WindowMananger.getInstance():resortLayer(self.windowName);
	end

	self:updataPos();
end

--暂时有443,473两种高度的界面。这里处理下高度443的适配，后期应该会统一高度，
function Lua_TipsWindow:updataPos()
	if self.h == 443 then
		self.winBg:SetDimensions(self.w, self.h);
		if self.showData.btnType == 1 then
			self.btnSure:setLocation(145, -(self.h / 2 - 82.5-15), 0);
			self.btnCancel:setLocation(-145, -(self.h / 2 - 82.5-15), 0);
		end
		self.titleName:setLocation(0, self.titleNamePosY, 0);
	end
end

function Lua_TipsWindow:updatabtnSureTime()
    self.sureCountDown = self.sureCountDown - 1;
    if self.sureCountDown <= 0 then
        Lua_CommonUtil.removeTimer(self, self.updatabtnSureTime);
        self.btnSure:setMouseEnable(true);
        self.btnSure:setStyle(1);
        self.btnSure:setLangValue(100002);
    else
        self.btnSure:setMouseEnable(false);
        self.btnSure:setStyle(7);
        self.btnSure.label = LanUtil.formateStr(107499, tostring(self.sureCountDown));
    end
end

function Lua_TipsWindow:setNeverTips()
	if self.showData ~= nil and self.showData.neverTip ~= nil and self.cbSelect ~= nil then
		DataCenter.neverTipData:setNeverValue(self.showData.neverTip, self.cbSelect.selected);
	end
end

function Lua_TipsWindow:cleanShowData()
	if self.showData ~= nil then
		self.showData.owner = nil;
		self.showData.cancelFun = nil;
		self.showData.sureFun = nil;
		self.showData = nil;
	end
end

function Lua_TipsWindow:onCheckBoxChange(bSelect)
	self:setNeverTips();
end

function Lua_TipsWindow:onMaskClick(go)
	if self.showData.onFunType == 0 then--关闭界面，执行取消按钮回调
		self:onCancelClick();
	elseif self.showData.onFunType == 1 then--关闭界面，执行确认按钮回调
		self:onSureClick();
	end
	self:superCall("onMaskClick");
end

function Lua_TipsWindow:onBtnCloseClick(go)
	if self.showData.onFunType == 0 then--关闭界面，执行取消按钮回调
		self:onCancelClick();
	elseif self.showData.onFunType == 1 then--关闭界面，执行确认按钮回调
		self:onSureClick();
	end
	self:superCall("onBtnCloseClick");
end

function Lua_TipsWindow:onCancelClick(go)
	self.showParams:shift();
	if self.showData ~= nil and self.showData.cancelFun ~= nil then
		self.showData.cancelFun(self.showData.owner, self.showData);
	end
	self:showNext();
end

function Lua_TipsWindow:onSureClick(go)
	self.showParams:shift();
	if self.showData ~= nil and self.showData.sureFun ~= nil then
		self.showData.sureFun(self.showData.owner, self.showData);
	end
	self:showNext();
end